package cc.toph.simplycompat.compat;

import cc.toph.simplycompat.registry.ItemsRegistry;
import cc.toph.simplycompat.util.WeaponType;
import dev.architectury.platform.Platform;

public class TFMG {

    public static final String MOD_ID = "tfmg";
    public static final String requiredVersion = "0.9.3-1.20.1";

    public static void register() {
        if (!passCheck()) return;

        for (WeaponType type : WeaponType.values()) {
            for (TFMGToolMaterials material : TFMGToolMaterials.values()) {
                if (material.isEnabled()) ItemsRegistry.registerSword(material, type);
            }
        }
    }

    public static boolean passCheck() {
        if (Platform.isModLoaded(MOD_ID)) {
            return Platform.getMod(MOD_ID).getVersion().compareTo(requiredVersion) >= 0;
        }
        return false;
    }
}