package cc.toph.simplycompat.compat;

import cc.toph.simplycompat.registry.ConfigRegistry;
import cc.toph.simplycompat.util.ToolMaterials;
import com.drmangotea.tfmg.registry.TFMGTiers;
import com.simibubi.create.AllTags;
import net.minecraft.world.item.Tier;
import net.minecraft.world.item.crafting.Ingredient;
import org.jetbrains.annotations.NotNull;

public enum TFMGToolMaterials implements ToolMaterials, Tier {
    ALUMINUM(
            TFMGTiers.ALUMINUM.getLevel(),
            TFMGTiers.ALUMINUM.getUses(),
            TFMGTiers.ALUMINUM.getSpeed(),
            TFMGTiers.ALUMINUM.getAttackDamageBonus(),
            ConfigRegistry.WEAPON_ATTRIBUTES.STEEL,
            TFMGTiers.ALUMINUM.getEnchantmentValue(),
            ConfigRegistry.WEAPON_ATTRIBUTES.STEEL_ENABLED,
            Ingredient.of(AllTags.AllItemTags.CREATE_INGOTS.tag)
    ),
    LEAD(
            TFMGTiers.LEAD.getLevel(),
            TFMGTiers.LEAD.getUses(),
            TFMGTiers.LEAD.getSpeed(),
            TFMGTiers.LEAD.getAttackDamageBonus(),
            ConfigRegistry.WEAPON_ATTRIBUTES.STEEL,
            TFMGTiers.LEAD.getEnchantmentValue(),
            ConfigRegistry.WEAPON_ATTRIBUTES.STEEL_ENABLED,
            Ingredient.of(AllTags.AllItemTags.CREATE_INGOTS.tag)
    ),
    STEEL(
            TFMGTiers.STEEL.getLevel(),
            TFMGTiers.STEEL.getUses(),
            TFMGTiers.STEEL.getSpeed(),
            TFMGTiers.STEEL.getAttackDamageBonus(),
            ConfigRegistry.WEAPON_ATTRIBUTES.STEEL,
            TFMGTiers.STEEL.getEnchantmentValue(),
            ConfigRegistry.WEAPON_ATTRIBUTES.STEEL_ENABLED,
            Ingredient.of(AllTags.AllItemTags.CREATE_INGOTS.tag)
    );

    private final int level;
    private final int uses;
    private final float speed;
    private final float attackDamageBonus;
    private final float damageModifier;
    private final int enchantmentValue;
    private final boolean enabled;
    private final Ingredient repairIngredient;

    TFMGToolMaterials(
            int level,
            int uses,
            float speed,
            float attackDamageBonus,
            float damageModifier,
            int enchantmentValue,
            boolean enabled,
            Ingredient repairIngredient
    ) {
        this.level = level;
        this.uses = uses;
        this.speed = speed;
        this.attackDamageBonus = attackDamageBonus;
        this.enchantmentValue = enchantmentValue;
        this.damageModifier = damageModifier;
        this.enabled = enabled;
        this.repairIngredient = repairIngredient;


    }

    @Override
    public String getName() {
        return this.name().toLowerCase();
    }

    @Override
    public int getUses() {
        return uses;
    }

    @Override
    public float getSpeed() {
        return speed;
    }

    @Override
    public float getAttackDamageBonus() {
        return attackDamageBonus;
    }

    @Override
    public float getDamageModifier() {
        return damageModifier;
    }

    @Override
    public int getLevel() {
        return level;
    }

    @Override
    public int getEnchantmentValue() {
        return enchantmentValue;
    }

    @Override
    public boolean isEnabled() {
        return enabled;
    }

    @Override
    public @NotNull Ingredient getRepairIngredient() {
        return this.repairIngredient;
    }

}